// ********************************************************************************************************
// <copyright file="FormGraph.cs" company="RAAFCOM B.V.">
//     Copyright (c) 2012 RAAFCOM B.V.. All rights reserved.
// </copyright>
// ********************************************************************************************************
// The contents of this file are subject to the Mozilla Public License Version 1.1 (the "License"); 
// you may not use this file except in compliance with the License. You may obtain a copy of the License at 
// http:// www.mozilla.org/MPL/ 
// Software distributed under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF 
// ANY KIND, either express or implied. See the License for the specificlanguage governing rights and 
// limitations under the License. 
// 
// The Initial Developer of this version is Maurits van Ravesteijn.
// 
// Contributor(s): (Open source contributors should list themselves and their modifications here). 
// Change Log: 
// Date           Changed By                Notes
// 07 Aug 2012  Maurits van Ravesteijn    Inital coding
// ********************************************************************************************************
namespace GridColorAnalyser.Forms
{
  using System;
  using System.Collections;
  using System.Collections.Generic;
  using System.ComponentModel;
  using System.Drawing;
  using System.Windows.Forms;
  using GridColorAnalyser.BO;

  /// <summary>
  /// Summary description for Form1.
  /// </summary>
  public class FormGraph : Form
  {
    //member variables
    private MapWinGIS.Grid grid;
    private BOMapWindow bomap;
    private BOGridFile bogrid;
    private GraphicHistogram graphicHistogram;
    private ArrayList arx1;
    private ArrayList ary1;
    private float xLeft, xRight;
    private float rightReal, leftReal;
    private bool mouseOverLeft, mouseOverRight;
    private bool mouseDownLeft, mouseDownRight;
    private bool graphCreated = false;
    float minD, maxD, maxS;
    private PictureBox pb1;
    private ComboBox cb1;
    private Label lb1;
    private Label lb2;
    private Label lb3;
    private TrackBar trb2;
    private TrackBar trb3;
    private ToolTip trb1TT;
    private IContainer components;
    private ToolTip trb2TT;
    private ToolTip trb3TT;
    private TrackBar trb1;

    public FormGraph()
    {
      //
      // Required for Windows Form Designer support
      //
      InitializeComponent();
    }

    public FormGraph(BOGridFile gr, BOMapWindow im)
    {
      this.InitializeComponent();

      this.bogrid = gr;
      this.grid = gr.GridFile;
      this.bomap = im;
      this.graphCreated = false;
      this.cb1.SelectedIndex = 0;
      this.CreateGraph(false, 0.0f);
    }

    #region Windows Form Designer generated code
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    /// 

    private void InitializeComponent()
    {
      this.components = new System.ComponentModel.Container();
      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(FormGraph));
      this.pb1 = new System.Windows.Forms.PictureBox();
      this.cb1 = new System.Windows.Forms.ComboBox();
      this.lb1 = new System.Windows.Forms.Label();
      this.lb2 = new System.Windows.Forms.Label();
      this.lb3 = new System.Windows.Forms.Label();
      this.trb1 = new System.Windows.Forms.TrackBar();
      this.trb2 = new System.Windows.Forms.TrackBar();
      this.trb3 = new System.Windows.Forms.TrackBar();
      this.trb1TT = new System.Windows.Forms.ToolTip(this.components);
      this.trb2TT = new System.Windows.Forms.ToolTip(this.components);
      this.trb3TT = new System.Windows.Forms.ToolTip(this.components);
      ((System.ComponentModel.ISupportInitialize)(this.pb1)).BeginInit();
      ((System.ComponentModel.ISupportInitialize)(this.trb1)).BeginInit();
      ((System.ComponentModel.ISupportInitialize)(this.trb2)).BeginInit();
      ((System.ComponentModel.ISupportInitialize)(this.trb3)).BeginInit();
      this.SuspendLayout();
      // 
      // pb1
      // 
      this.pb1.Location = new System.Drawing.Point(13, 13);
      this.pb1.Name = "pb1";
      this.pb1.Size = new System.Drawing.Size(603, 132);
      this.pb1.TabIndex = 0;
      this.pb1.TabStop = false;
      this.pb1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pb1_MouseMove);
      this.pb1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pb1_MouseDown);
      this.pb1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pb1_MouseUp);
      // 
      // cb1
      // 
      this.cb1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
      this.cb1.FormattingEnabled = true;
      this.cb1.Items.AddRange(new object[] {
            "Rainbow",
            "SummerMountains",
            "DeadSea",
            "Desert",
            "FallLeaves",
            "Glaciers",
            "ValleyFires"});
      this.cb1.Location = new System.Drawing.Point(639, 124);
      this.cb1.Name = "cb1";
      this.cb1.Size = new System.Drawing.Size(121, 21);
      this.cb1.TabIndex = 1;
      this.cb1.SelectedIndexChanged += new System.EventHandler(this.cb1_ValueChanged);
      // 
      // lb1
      // 
      this.lb1.AutoSize = true;
      this.lb1.Location = new System.Drawing.Point(636, 13);
      this.lb1.Name = "lb1";
      this.lb1.Size = new System.Drawing.Size(19, 13);
      this.lb1.TabIndex = 2;
      this.lb1.Text = "Int";
      // 
      // lb2
      // 
      this.lb2.AutoSize = true;
      this.lb2.Location = new System.Drawing.Point(685, 13);
      this.lb2.Name = "lb2";
      this.lb2.Size = new System.Drawing.Size(21, 13);
      this.lb2.TabIndex = 3;
      this.lb2.Text = "Azi";
      // 
      // lb3
      // 
      this.lb3.AutoSize = true;
      this.lb3.Location = new System.Drawing.Point(734, 13);
      this.lb3.Name = "lb3";
      this.lb3.Size = new System.Drawing.Size(31, 13);
      this.lb3.TabIndex = 4;
      this.lb3.Text = "Elev.";
      // 
      // trb1
      // 
      this.trb1.Location = new System.Drawing.Point(639, 33);
      this.trb1.Maximum = 100;
      this.trb1.Name = "trb1";
      this.trb1.Orientation = System.Windows.Forms.Orientation.Vertical;
      this.trb1.Size = new System.Drawing.Size(45, 90);
      this.trb1.TabIndex = 5;
      this.trb1.TickFrequency = 10;
      this.trb1TT.SetToolTip(this.trb1, "Light source intensity");
      this.trb1.Value = 50;
      this.trb1.ValueChanged += new System.EventHandler(this.trb1_ValueChanged);
      // 
      // trb2
      // 
      this.trb2.Location = new System.Drawing.Point(688, 33);
      this.trb2.Maximum = 100;
      this.trb2.Name = "trb2";
      this.trb2.Orientation = System.Windows.Forms.Orientation.Vertical;
      this.trb2.Size = new System.Drawing.Size(45, 90);
      this.trb2.TabIndex = 6;
      this.trb2.TickFrequency = 10;
      this.trb2TT.SetToolTip(this.trb2, "Light source azimuth range -180->180 degrees");
      this.trb2.Value = 50;
      this.trb2.ValueChanged += new System.EventHandler(this.trb1_ValueChanged);
      // 
      // trb3
      // 
      this.trb3.Location = new System.Drawing.Point(737, 33);
      this.trb3.Maximum = 90;
      this.trb3.Name = "trb3";
      this.trb3.Orientation = System.Windows.Forms.Orientation.Vertical;
      this.trb3.Size = new System.Drawing.Size(45, 90);
      this.trb3.TabIndex = 7;
      this.trb3.TickFrequency = 10;
      this.trb3TT.SetToolTip(this.trb3, "Light Source elevation range 0-90 degrees");
      this.trb3.Value = 50;
      this.trb3.ValueChanged += new System.EventHandler(this.trb1_ValueChanged);
      // 
      // trb1TT
      // 
      this.trb1TT.AutomaticDelay = 2000;
      this.trb1TT.AutoPopDelay = 20000;
      this.trb1TT.InitialDelay = 1;
      this.trb1TT.ReshowDelay = 400;
      this.trb1TT.ShowAlways = true;
      // 
      // trb2TT
      // 
      this.trb2TT.AutomaticDelay = 2000;
      this.trb2TT.AutoPopDelay = 20000;
      this.trb2TT.InitialDelay = 1;
      this.trb2TT.ReshowDelay = 400;
      this.trb2TT.ShowAlways = true;
      // 
      // trb3TT
      // 
      this.trb3TT.AutomaticDelay = 2000;
      this.trb3TT.AutoPopDelay = 20000;
      this.trb3TT.InitialDelay = 1;
      this.trb3TT.ReshowDelay = 400;
      this.trb3TT.ShowAlways = true;
      // 
      // FormGraph
      // 
      this.ClientSize = new System.Drawing.Size(780, 161);
      this.Controls.Add(this.trb3);
      this.Controls.Add(this.trb2);
      this.Controls.Add(this.trb1);
      this.Controls.Add(this.lb3);
      this.Controls.Add(this.lb2);
      this.Controls.Add(this.lb1);
      this.Controls.Add(this.cb1);
      this.Controls.Add(this.pb1);
      this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
      this.Name = "FormGraph";
      this.Text = "Grid Color Analyser";
      ((System.ComponentModel.ISupportInitialize)(this.pb1)).EndInit();
      ((System.ComponentModel.ISupportInitialize)(this.trb1)).EndInit();
      ((System.ComponentModel.ISupportInitialize)(this.trb2)).EndInit();
      ((System.ComponentModel.ISupportInitialize)(this.trb3)).EndInit();
      this.ResumeLayout(false);
      this.PerformLayout();

    }
    #endregion

    #region component callbacks

    // Trackbar value changed
    private void cb1_ValueChanged(Object sender, EventArgs e)
    {
      // remove Map
      //legend1.Layers.Remove(handle_grid);
      // redraw Map
      AddLayer();
      // move depth and contour above Map
      /*if (handle_contour > -1)
      {
          legend1.Layers.MoveLayerWithinGroup(handle_contour, 2);
      }
      if (handle_depth > -1)
      {
          legend1.Layers.MoveLayerWithinGroup(handle_depth, 2);
      }   
      legend1.Refresh();*/
      if (graphCreated)
      {
        CreateGraph(true, 0.0f);
      }

    }

    private void trb1_ValueChanged(Object sender, EventArgs e)
    {
      // remove Map
      //legend1.Layers.Remove(handle_grid);
      // redraw Map
      AddLayer();
      // move depth and contour  above Map
      /*if (handle_contour > -1)
      {
          legend1.Layers.MoveLayerWithinGroup(handle_contour, 2);
      }
      if (handle_depth > -1)
      {
          legend1.Layers.MoveLayerWithinGroup(handle_depth, 2);
      }
      legend1.Refresh();*/
    }






    private void pb1_MouseMove(object sender, MouseEventArgs e)
    {
      if (graphCreated)
      {
        mouseOverLeft = false;
        mouseOverRight = false;
        float val = ((e.X - graphicHistogram.XSlice) / graphicHistogram.GraphXprop) + minD;
        if (val > 100.0 || val < -100.0)
        {
          //this.statusBar1.Panels[0].Text = "Hist X = " + val.ToString("0.0");
        }
        else
        {
          //this.statusBar1.Panels[0].Text = "Hist X = " + val.ToString();
        }
        if (mouseDownLeft || mouseDownRight)
        {
          Cursor.Current = Cursors.VSplit;
          if (mouseDownLeft)
          {
            if (e.X < (xRight + graphicHistogram.XSlice - 20.0))
            {
              CreateGraph(true, (float)e.X);
            }
            else
            {
              CreateGraph(true, xRight + graphicHistogram.XSlice - 20.0f);
            }
          }
          else if (mouseDownRight)
          {
            if (e.X > (xLeft + graphicHistogram.XSlice + 20.0))
            {
              CreateGraph(true, (float)e.X);
            }
            else
            {
              CreateGraph(true, xLeft + graphicHistogram.XSlice + 20.0f);
            }
          }

        }
        else
        {
          if (e.X > (xLeft + graphicHistogram.XSlice - 10.0) && e.X < (xLeft + graphicHistogram.XSlice + 10.0))
          {
            mouseOverLeft = true;
            Cursor.Current = Cursors.VSplit;
          }
          else if (e.X > (xRight + graphicHistogram.XSlice - 10.0) && e.X < (xRight + graphicHistogram.XSlice + 10.0))
          {
            mouseOverRight = true;
            Cursor.Current = Cursors.VSplit;
          }

        }
      }
    }

    private void pb1_MouseDown(object sender, MouseEventArgs e)
    {
      if (graphCreated)
      {
        Cursor.Current = Cursors.VSplit;
        mouseDownLeft = false;
        if (mouseOverLeft) mouseDownLeft = true;
        mouseDownRight = false;
        if (mouseOverRight) mouseDownRight = true;
      }
    }

    private void pb1_MouseUp(object sender, MouseEventArgs e)
    {
      float leftReal = 0.0f;
      float rightReal = 0.0f;
      float newXprop = 0.0f;
      float newXrealValue = 0.0f;
      if (graphCreated)
      {
        if (mouseDownLeft || mouseDownRight)
        {
          // calculate dimensions new graph
          if (mouseDownLeft)
          {
            if (e.X < (xRight + graphicHistogram.XSlice - 20.0))
            {
              leftReal = ((e.X - graphicHistogram.XSlice) / graphicHistogram.GraphXprop) + minD;
            }
            else
            {
              leftReal = ((xRight - 20.0f) / graphicHistogram.GraphXprop) + minD;

            }
            rightReal = (xRight / graphicHistogram.GraphXprop) + minD;
          }
          else if (mouseDownRight)
          {
            leftReal = (xLeft / graphicHistogram.GraphXprop) + minD;
            if (e.X > (xLeft + graphicHistogram.XSlice + 20.0))
            {
              rightReal = ((e.X - graphicHistogram.XSlice) / graphicHistogram.GraphXprop) + minD;
            }
            else
            {
              rightReal = ((xLeft + 20.0f) / graphicHistogram.GraphXprop) + minD;
            }
          }
          if (leftReal < (float)Convert.ToDouble(grid.Minimum)) leftReal = (float)Convert.ToDouble(grid.Minimum);
          if (rightReal > (float)Convert.ToDouble(grid.Maximum)) rightReal = (float)Convert.ToDouble(grid.Maximum);
          newXrealValue = (float)(((rightReal - leftReal) * 50) / (xRight - xLeft));
          //newXprop = 50 / graphicHistogram.Multip(newXrealValue);
          newXprop = 50 / newXrealValue;
          minD = leftReal - (xLeft / newXprop);
          maxD = rightReal + ((graphicHistogram.Width - (2 * graphicHistogram.XSlice) - xRight) / newXprop);
          // reset status
          mouseDownLeft = false;
          mouseDownRight = false;
          Cursor.Current = Cursors.Default;
          // make graph
          CreateGraph(true, 0.0f);
          // redraw map
          trb1_ValueChanged(null, null);
        }
      }
    }


    #endregion

    private void AddLayer()
    {
      MapWinGIS.GridColorScheme gridScheme = new MapWinGIS.GridColorScheme();
      OpenFileDialog openDlg = new OpenFileDialog();

      // build the color scheme
      ColorSchemes_velsto csv1 = new ColorSchemes_velsto();
      gridScheme = csv1.setColorScheme(cb1.SelectedIndex + 1, gridScheme, graphCreated,
          leftReal, rightReal,
          Convert.ToDouble(grid.Minimum), Convert.ToDouble(grid.Maximum));
      double lightInt, lightAzi, lightElev;
      lightInt = (double)trb1.Value / ((double)(trb1.Maximum - trb1.Minimum));
      lightAzi = (double)trb2.Value;
      lightElev = (double)trb3.Value;
      gridScheme.LightSourceIntensity = lightInt;
      gridScheme.SetLightSource(lightAzi, lightElev);

      // convert the grid to a image
      bomap.UpdateMap(bogrid, gridScheme);
    }

    #region ICallback Members

    public void Error(string KeyOfSender, string ErrorMsg)
    {
      // TODO:  Add Form1.Error implementation
    }

    public void Progress(string KeyOfSender, int Percent, string Message)
    {
      //progressBar1.Value = Percent;
      //statusBar1.Panels[0].Text =Message;
    }

    #endregion

    private void getHist(out ArrayList arX, out ArrayList arY, out float minD, out float maxD, out float maxS)
    {
      cBack cb = new cBack();
      double histInterval = 0.0;
      double histMin = 0.0, histMax = 0.0;
      int nrHist = 200;
      List<double> lsHistValues;
      arX = new ArrayList();
      arY = new ArrayList();
      List<HistInterval> lsHist = new List<HistInterval>();
      HistInterval hint;
      // Add first interval
      XYPointFile xyz1 = new XYPointFile();
      lsHistValues = xyz1.getContourIntervals(nrHist, Convert.ToDouble(grid.Minimum),
                                                  Convert.ToDouble(grid.Maximum));
      histInterval = lsHistValues[1] - lsHistValues[0];
      histMin = lsHistValues[0] - histInterval;
      histMax = lsHistValues[lsHistValues.Count - 1] + histInterval;
      //MessageBox.Show(histInterval.ToString() + " " + histMin.ToString() + " " + histMax.ToString());
      hint = new HistInterval(histMin, lsHistValues[0], 0);
      lsHist.Add(hint);

      // Add Intermediate intervals
      for (int i = 0; i < lsHistValues.Count - 1; i++)
      {
        hint = new HistInterval(lsHistValues[i], lsHistValues[i + 1], 0);
        lsHist.Add(hint);
      }
      // Add Last Interval
      hint = new HistInterval(lsHistValues[lsHistValues.Count - 1], histMax, 0);
      lsHist.Add(hint);
      cb.Show();
      int p1 = 0;
      int numOfCol = grid.Header.NumberCols;
      int numOfRow = grid.Header.NumberRows;
      double val = 0.0;
      double dval = 0.0;
      double dnodata = (double)grid.Header.NodataValue;
      int k = 0;
      for (int jc = 0; jc < numOfCol; jc++)
      {
        p1++;
        if (p1 == 10)
        {
          cb.Progress("", (int)(100.0 * ((double)jc / (double)numOfCol)), "Creating Histogram");
          p1 = 0;
        }
        for (int jr = 0; jr < numOfRow; jr++)
        {

          val = Convert.ToDouble(grid.get_Value(jc, jr));

          if (val != dnodata)
          {
            dval = ((val - histMin) / histInterval);
            k = (int)dval;
            if (k >= (lsHist.Count - 1)) { k = lsHist.Count - 1; }
            lsHist[k].Y++;
          }
          else
          {
            //MessageBox.Show(k.ToString());
          }

        }
      }
      cb.Close();
      minD = 999999.9f;
      maxD = -9999999.9f;
      maxS = -9999999.9f;
      for (int i = 0; i < lsHist.Count; i++)
      {
        arX.Add(lsHist[i].X_from);
        arY.Add(lsHist[i].Y);
        if (lsHist[i].X_from < minD)
        {
          minD = (float)lsHist[i].X_from;
        }
        if (lsHist[i].X_till > maxD)
        {
          maxD = (float)lsHist[i].X_till;
        }
        if (lsHist[i].Y > maxS)
        {
          maxS = (float)lsHist[i].Y;
        }
      }
      return;
    }

    private void CreateGraph(bool mmredraw, float x)
    {
      ////Create an instance of graphicHistogram.cs file.
      graphicHistogram = new GraphicHistogram();
      ////Set the height for the graph image.
      graphicHistogram.Height = 120;
      ////Set the width for the graph image.
      graphicHistogram.Width = 600;
      ////Set the Slices(partition in Axis) for X and Y Axis.
      graphicHistogram.XSlice = 20;
      graphicHistogram.YSlice = 20;
      ////Set the Title for both Axis.
      graphicHistogram.XAxisText = "Value";
      graphicHistogram.YAxisText = "Hist";

      //graphicHistogram.XrealValue = 10.0F;
      //graphicHistogram.YrealValue = 10.0F;

      ////Set the Graph Title.;
      graphicHistogram.Title = "Histogram";
      ////Set the Backcolor and forecolor for the graph title.
      graphicHistogram.TitleBackColor = Color.White;
      graphicHistogram.TitleForeColor = Color.Black;
      ////Initialize the graph object to draw.
      graphicHistogram.InitializeGraph();
      // calc histogram array when graph first drafted
      if (!graphCreated)
      {
        arx1 = new ArrayList();
        ary1 = new ArrayList();
        minD = 0.0f;
        maxD = 0.0f;
        maxS = 0.0f;
        this.getHist(out arx1, out ary1, out minD, out maxD, out maxS);
      }
      graphicHistogram.MinD = minD;
      graphicHistogram.XrealValue = (float)((maxD - minD) * 50) / (graphicHistogram.Width -
          (2 * graphicHistogram.XSlice));
      graphicHistogram.GraphXprop = 50 / graphicHistogram.XrealValue;
      graphicHistogram.YrealValue = (float)(maxS * 50) / (graphicHistogram.Height -
          (2 * graphicHistogram.YSlice));
      graphicHistogram.X1Axis = arx1;
      graphicHistogram.Y1Axis = ary1;
      xLeft = 80.0f;
      xRight = 520.0f;
      graphicHistogram.DrawLine(xLeft, -10, xLeft, 110);
      graphicHistogram.DrawLine(xRight, -10, xRight, 110);
      // (re)calc leftReal,rightReal required for colors in histogram and redrawing map
      leftReal = (xLeft / graphicHistogram.GraphXprop) + minD;
      rightReal = (xRight / graphicHistogram.GraphXprop) + minD;
      // get colors for histogram
      ColorSchemes_velsto csc1 = new ColorSchemes_velsto();
      graphicHistogram.XYColor = csc1.setHistColorScheme(cb1.SelectedIndex + 1, arx1,
                                                         leftReal, rightReal,
                                                         Convert.ToDouble(grid.Minimum), Convert.ToDouble(grid.Maximum));
      //MessageBox.Show(graphicHistogram.XYColor.Count.ToString() + " " + graphicHistogram.X1Axis.Count.ToString());
      // draw histogram
      graphicHistogram.CreateLines();
      // draw line when dragged
      if (mmredraw && (mouseDownLeft || mouseDownRight))
      {
        graphicHistogram.DrawLine(x - graphicHistogram.XSlice, -10, x - graphicHistogram.XSlice, 110);
      }
      // Draw XAxis values
      List<double> lsXAxisValues;
      int nrXAxis = 6;
      XYPointFile xyz1 = new XYPointFile();
      lsXAxisValues = xyz1.getContourIntervals(nrXAxis, (double)minD, (double)maxD);
      graphicHistogram.SetXAxis2(lsXAxisValues);
      // Draw Yaxis values
      Bitmap bmp = graphicHistogram.GetGraph();
      this.pb1.Image = bmp;
      graphCreated = true;
      // redraw map when graph first created or mouse up when lines dragged
      if (!mmredraw)
      {
        trb1_ValueChanged(null, null);
      }
      return;
    }

    public void RespondToLayerSelected(int handle)
    {
      if (this.bomap.Refreshing || this.bogrid.LayerHandle == handle)
        return;

      this.Close();
    }

    public void RespondToLayerRemoved(int handle)
    {
      if (this.bomap.Refreshing || this.bogrid.LayerHandle != handle)
        return;

      this.Close();
    }
  }
}
