// ********************************************************************************************************
// <copyright file="Layers.cs" company="TopX Geo-ICT">
//     Copyright (c) 2011-2013 TopX Geo-ICT. All rights reserved.
// </copyright>
// ********************************************************************************************************
// The contents of this file are subject to the Mozilla Public License Version 1.1 (the "License"); 
// you may not use this file except in compliance with the License. You may obtain a copy of the License at 
// http:// www.mozilla.org/MPL/ 
// Software distributed under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF 
// ANY KIND, either express or implied. See the License for the specific language governing rights and 
// limitations under the License. 
// 
// The Original Code is MapWindow Open Source MeemsTools Plug-in. 
// 
// The Initial Developer of this version of the Original Code is Paul Meems.
// 
// Contributor(s): (Open source contributors should list themselves and their modifications here). 
// Change Log: 
// Date           Changed By      Notes
// 13 April 2008  Paul Meems      Inital upload the MW SVN repository
// 28 August 2009 Paul Meems      Made the code StyleCop compliant
// 5  May 2011    Paul Meems      Made changes as suggested by ReSharper   
// 09 Sept 2013   Paul Meems      Converted to a template plug-in for general use
// ********************************************************************************************************

namespace PluginTemplate.Forms
{
  #region Usings

  using System;
  using System.Reflection;
  using System.Windows.Forms;
  using MapWindow.Interfaces;

  using PluginTemplate.Classes;

  #endregion

  /// <summary>
  ///   This class holds all code used in this form
  /// </summary>
  public partial class Layers : Form
  {
    /// <summary>
    ///   Initializes a new instance of the Layers class.
    /// </summary>
    public Layers()
    {
      this.InitializeComponent();

      // Set versionnr in statuslabel:
      this.VersionLabel.Text = @"v" + Assembly.GetExecutingAssembly().GetName().Version;

      // Fill combobox:  
      Utils.FillVisibleLayers(this);
    }

    /// <summary>
    ///   Index changed event of cboLayers
    /// </summary>
    /// <param name = "sender">Sender (object)</param>
    /// <param name = "e">Event arguments</param>
    private void CboLayersSelectedIndexChanged(object sender, EventArgs e)
    {
      // Get data from combobox
      // C#3.0: Implicitly Typed Local Variables and Arrays:
      var selectedLayerItem = (Layer)this.cboLayers.SelectedItem;
      if (selectedLayerItem == null)
      {
        return;
      }

      this.lblHandle.Text = @"Handle: " + selectedLayerItem.Handle;
      this.lblName.Text = @"Name: " + selectedLayerItem.Name;
      this.lblType.Text = @"Type: " + selectedLayerItem.LayerType;
    }
  }
}